#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=logo.ico
#AutoIt3Wrapper_Res_Comment=DirInstall
#AutoIt3Wrapper_Res_Description=DirInstall
#AutoIt3Wrapper_Res_Fileversion=3.0.0.0
#AutoIt3Wrapper_Res_LegalCopyright=(c) 2010 ZeShrek - http://www.autoitscript.fr/
#AutoIt3Wrapper_Res_Language=1036
#AutoIt3Wrapper_Res_requestedExecutionLevel=requireAdministrator
#AutoIt3Wrapper_Res_File_Add=logo.png, rt_rcdata, LOGO
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#cs ----------------------------------------------------------------------------
	[DirInstall]
	AutoIt Version: 3.3.6.1
	Author:         ZeShrek

	Script Function:
	Plugin / tool for SciTE

#ce ----------------------------------------------------------------------------

Opt("TrayIconHide", 1) ; pas de traymenu
AutoItSetOption("MustDeclareVars", 1) ; force la dclaration des variables

#Region *** Includes
#include <File.au3>
#include <GUIConstantsEx.au3>
#include <GuiEdit.au3>
#include <GUIListView.au3>
#include <GuiTreeView.au3>
#include <ListViewConstants.au3>
#include <resources.au3>
#include <StaticConstants.au3>
#include <TreeviewConstants.au3>
#include <WindowsConstants.au3>
#EndRegion *** Includes

#Region *** Variables & constantes
;~  ### Dclaration des variables
;		 Form1
Global $Form1, $SrcLabel, $Input1, $Button1, $TreeView1, $hTreeView, $TotLabel, $Pic1, $DstLabel, $Input2, $Button2, $ListView2, $ProgressYesNo, $Button3, $Button4
;		AddDest
Global $Destpath, $Idx = 1, $Update = False
;		AddSource
Global $rootpath
;~  ### Dclaration des tableaux
Dim $Folder[1]
Dim $TreeViewItem[$Idx + 1][4]
;~  ### Dclaration des constantes
Global Const $Version = "3.0"
#EndRegion *** Variables & constantes

#Region *** Execution
;~ SciTE Plugin install
_PluginInstall()
;~ DirInstall execution
_Main()
#EndRegion *** Execution

#Region *** Fonctions
Func _AddDest()
	AdlibUnRegister("_FillList")
	$Destpath = _SelectDestination()
	If $Destpath <> "" Then
		GUICtrlSetData($Input2, $Destpath)
		$Update = True
		GUICtrlSetState($Button3, $GUI_ENABLE)
		GUICtrlSetOnEvent($Button3, "_Valid")
		AdlibRegister("_FillList")
	EndIf
EndFunc   ;==>_AddDest

Func _AddSource()
	Local $rootpathsav = $rootpath
	AdlibUnRegister("_FillList")
	$rootpath = FileSelectFolder("Inital location", "", 2, @MyDocumentsDir)
	If $rootpath = "" Then $rootpath = $rootpathsav
	If $rootpath <> "" Then
		$Idx = 1
		GUICtrlSetData($Input1, $rootpath)
		_GUICtrlTreeView_DeleteAll($TreeView1)
		$TreeViewItem[0][0] = GUICtrlCreateTreeViewItem($rootpath, $TreeView1)
		_FillTree($TreeViewItem[0][0], $rootpath, $Idx, $TreeViewItem)
		GUICtrlSetState($TreeViewItem[0][0], BitOR($GUI_DEFBUTTON, $GUI_EXPAND))
		GUICtrlSetColor($TreeViewItem[0][0], 0x0000AA)
		RemoveCheckbox($TreeView1, $TreeViewItem[0][0])
		_GUICtrlListView_DeleteAllItems($ListView2)
		GUICtrlSetState($Button2, $GUI_ENABLE)
		GUICtrlSetState($Input2, $GUI_ENABLE)
		GUICtrlSetData($Input2, "Destination")
		$Destpath = ""
		GUICtrlSetState($Button3, $GUI_DISABLE)
		GUICtrlSetData($TotLabel, $Idx & " elements to install")
		GUICtrlSetOnEvent($Button2, "_AddDest")
	Else
		_GUICtrlListView_DeleteAllItems($ListView2)
		GUICtrlSetState($Button2, $GUI_DISABLE)
		GUICtrlSetState($Input2, $GUI_DISABLE)
		GUICtrlSetData($Input2, "Destination Path")
		$Destpath = ""
		GUICtrlSetState($Button3, $GUI_DISABLE)
		GUICtrlSetData($TotLabel, $Idx & " elements to install")
		GUICtrlSetOnEvent($Button2, "")
	EndIf
	AdlibRegister("_FillList")
EndFunc   ;==>_AddSource

Func _Check($hWnd, $Msg, $wParam, $lParam)
	Local $hWndFrom, $idFrom, $iCode, $tNMHDR = DllStructCreate("hwnd hwndFrom;int idFrom;int code", $lParam)
	$hWndFrom = DllStructGetData($tNMHDR, "hwndFrom")
	$iCode = DllStructGetData($tNMHDR, "code")
	If $hWndFrom = $hTreeView Then
		Switch $iCode
			Case $NM_CLICK
				Local $tMPos = _WinAPI_GetMousePos(True, $hWndFrom), $tHit = _GUICtrlTreeView_HitTestEx($hWndFrom, DllStructGetData($tMPos, 1), DllStructGetData($tMPos, 2))
				Local $hItem = DllStructGetData($tHit, "Item"), $iFlags = DllStructGetData($tHit, "Flags")
				If $hItem <> 0 And BitAND($iFlags, $TVHT_ONITEMSTATEICON) Then
					_CheckChildren($hWndFrom, $hItem, 1)
					_CheckParents($hWndFrom, $hItem)
				EndIf
			Case $TVN_KEYDOWN
				Local $tNMTVKEY = DllStructCreate("hwnd;int;int;short key;uint", $lParam)
				Local $hSelected = _GUICtrlTreeView_GetSelection($hWndFrom)
				If DllStructGetData($tNMTVKEY, "key") = 0x20 And $hSelected Then ;;space
					_CheckChildren($hWndFrom, $hSelected, 1)
					_CheckParents($hWndFrom, $hSelected)
				EndIf
			Case Else
		EndSwitch
	EndIf
EndFunc   ;==>_Check

Func _CheckChildren($hWnd, $hItem, $fTop = 0)
	$Update = True
	Local $fChecked = _GUICtrlTreeView_GetChecked($hWnd, $hItem)
	If $fTop Then $fChecked = Not $fChecked
	If _GUICtrlTreeView_GetChildren($hWnd, $hItem) Then
		Local $hChild = _GUICtrlTreeView_GetFirstChild($hWnd, $hItem)
		Do
			_GUICtrlTreeView_SetChecked($hWnd, $hChild, $fChecked)
			If _GUICtrlTreeView_GetChildren($hWnd, $hChild) Then
				_CheckChildren($hWnd, $hChild)
			EndIf
			$hChild = _GUICtrlTreeView_GetNextChild($hWnd, $hChild)
		Until $hChild = 0
	EndIf
EndFunc   ;==>_CheckChildren

Func _CheckParents($hWnd, $hItem, $fTop = False)
	$Update = True
	Local $fChecked = False
	If $fTop = False Then $fChecked = _GUICtrlTreeView_GetChecked($hWnd, $hItem)
	If $fChecked = False Then
		Local $hParent = _GUICtrlTreeView_GetParentHandle($hWnd, $hItem)
		If $hParent <> GUICtrlGetHandle($TreeViewItem[0][0]) Then
			_GUICtrlTreeView_SetChecked($hWnd, $hParent, True)
			_CheckParents($hWnd, $hParent, True)
		EndIf
	EndIf
EndFunc   ;==>_CheckParents

Func _ExitApp()
	Exit
EndFunc   ;==>_ExitApp

Func _FillList()
	Local $NbCheck = 0
	If $Destpath <> "" And $Update = True Then
		_GUICtrlListView_DeleteAllItems($ListView2)
		For $i = 1 To $Idx
			If BitAND(GUICtrlRead($TreeViewItem[$i][0]), $GUI_CHECKED) = $GUI_CHECKED Then
				GUICtrlCreateListViewItem($Destpath & $TreeViewItem[$i][2] & Chr(34), $ListView2)
				GUICtrlSetColor($TreeViewItem[$i][0], 0x00AA00)
				$NbCheck = $NbCheck + 1
			Else
				GUICtrlSetColor($TreeViewItem[$i][0], 0xFF0000)
			EndIf
		Next
		GUICtrlSetData($TotLabel, $NbCheck & " elements to install")
		$Update = False
	ElseIf $Update = True Then
		For $i = 1 To $Idx
			If BitAND(GUICtrlRead($TreeViewItem[$i][0]), $GUI_CHECKED) = $GUI_CHECKED Then
				$NbCheck = $NbCheck + 1
			EndIf
		Next
		GUICtrlSetData($TotLabel, $NbCheck & " elements to install")
	EndIf
EndFunc   ;==>_FillList

Func _FillTree($Tree, $Path, ByRef $Idx, ByRef $TreeViewItem)
	Local $i, $iF, $aFiles, $aDirectorys
;~ 	ReDim $TreeViewItem[$idx + 1][5]
;~ $TreeViewItem[x][0]	$ID du treeviewitem en cours
;~ $TreeViewItem[x][1]	contenu du treeviewitem
;~ $TreeViewItem[x][2]	chemin vers le fichier concern
;~ $TreeViewItem[x][3]	0 = fichier
;~ 						1 = dossier
	;Insertion des sous dossiers
	$aDirectorys = _FileListToArray($Path, '*.*', 2)
	_ArrayDelete($aDirectorys, 0)
	_ArraySort($aDirectorys)
	For $i = 0 To UBound($aDirectorys) - 1
		ReDim $TreeViewItem[$Idx + 1][4]
		$TreeViewItem[$Idx][0] = GUICtrlCreateTreeViewItem($aDirectorys[$i], $Tree)
		$TreeViewItem[$Idx][1] = $aDirectorys[$i]
		$TreeViewItem[$Idx][2] = StringTrimLeft($Path & "\" & $aDirectorys[$i], StringLen($rootpath) + 1)
		GUICtrlSetState($TreeViewItem[$Idx][0], BitOR($GUI_DEFBUTTON, $GUI_CHECKED))
		$TreeViewItem[$Idx][3] = 1
		$Idx = $Idx + 1
		ReDim $TreeViewItem[$Idx + 1][4]
		_FillTree($TreeViewItem[$Idx - 1][0], $Path & "\" & $aDirectorys[$i], $Idx, $TreeViewItem)
	Next
	;insertion du contenu du dossier
	$aFiles = _FileListToArray($Path, "*", 1)
	_ArrayDelete($aFiles, 0)
	_ArraySort($aFiles)
	For $iF = 0 To UBound($aFiles) - 1
		$TreeViewItem[$Idx][0] = GUICtrlCreateTreeViewItem($aFiles[$iF], $Tree)
		$TreeViewItem[$Idx][1] = $aFiles[$iF]
		$TreeViewItem[$Idx][2] = StringTrimLeft($Path & "\" & $aFiles[$iF], StringLen($rootpath) + 1)
		GUICtrlSetState($TreeViewItem[$Idx][0], $GUI_CHECKED)
		$TreeViewItem[$Idx][3] = 0
		$Idx = $Idx + 1
		ReDim $TreeViewItem[$Idx + 1][4]
	Next
	$Update = True
EndFunc   ;==>_FillTree

Func _Main()
	Opt("GUIOnEventMode", 1)

	$Form1 = GUICreate("DirInstall v" & $Version, 520, 530, -1, -1, BitOR($DS_MODALFRAME, $WS_CAPTION))
	$SrcLabel = GUICtrlCreateLabel("Initial location of files to install", 10, 10, 142, 17)
	$Input1 = GUICtrlCreateLabel("Source Path", 10, 30, 480, 21, -1, $WS_EX_CLIENTEDGE)
	GUICtrlSetTip($Input1, "Clic the button at the right end of this input field to select the source path")
	GUICtrlSetBkColor($Input1, 0xFFFFFF)
	$Button1 = GUICtrlCreateButton("...", 490, 30, 20, 21, $WS_GROUP)
	$TreeView1 = GUICtrlCreateTreeView(10, 60, 500, 170, BitOR($TVS_HASBUTTONS, $TVS_DISABLEDRAGDROP, $TVS_HASLINES, $TVS_LINESATROOT, $TVS_DISABLEDRAGDROP, $TVS_CHECKBOXES), $WS_EX_CLIENTEDGE)
	$hTreeView = GUICtrlGetHandle($TreeView1)
	$TotLabel = GUICtrlCreateLabel(" elements to install", 10, 235, 142, 17)
	$Pic1 = GUICtrlCreatePic("", 426, 239, 64, 64)
	_ResourceSetImageToCtrl($Pic1, "LOGO")
	$DstLabel = GUICtrlCreateLabel("Destination location of files to install", 10, 290, 171, 17)
	$Input2 = GUICtrlCreateLabel("Destination Path", 10, 310, 480, 21, -1, $WS_EX_CLIENTEDGE)
	GUICtrlSetBkColor($Input2, 0xFFFFFF)
	GUICtrlSetTip($Input2, "Clic the button at the right end of this input field to select the destination")
	$Button2 = GUICtrlCreateButton("...", 490, 310, 20, 21, $WS_GROUP)
	$ListView2 = GUICtrlCreateListView("Destination", 10, 340, 500, 110)
	_GUICtrlListView_SetColumnWidth($ListView2, 0, 480)
	$ProgressYesNo = GUICtrlCreateCheckbox("Display ProgressBar during installation", 10, 458, 500, 20)
	GUICtrlSetTip($ProgressYesNo, "Check to add a GUI that displays a progress bar during folders creation and files installation")
	$Button3 = GUICtrlCreateButton("Ok", 40, 488, 75, 25, $WS_GROUP)
	$Button4 = GUICtrlCreateButton("Cancel", 415, 488, 75, 25, $WS_GROUP)

	GUISetState(@SW_SHOW, $Form1)

	GUIRegisterMsg($WM_NOTIFY, "_Check")
	GUICtrlSetState($Input2, $GUI_DISABLE)
	GUICtrlSetState($Button2, $GUI_DISABLE)
	GUICtrlSetState($Button3, $GUI_DISABLE)
	GUICtrlSetOnEvent($Button1, "_AddSource")
	GUICtrlSetOnEvent($Button4, "_ExitApp")
	While 1
		Sleep(100)
	WEnd
EndFunc   ;==>_Main

Func _PluginInstall()
	If @Compiled Then
		If $cmdline[0] = "" Then
			Local $file, $Nblignes, $Trouve, $ndx, $Button1, $nMsg
			Local $ScitePath = StringSplit(RegRead("HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows\CurrentVersion\App Paths\SciTE.exe", ""), "\")
			Local $InstallDir = ""
			For $i = 1 To $ScitePath[0] - 1
				$InstallDir = $InstallDir & $ScitePath[$i] & "\"
			Next
			DirCreate($InstallDir & "DirInstall")
			FileCopy(@ScriptFullPath, $InstallDir & "DirInstall\DirInstall.exe", 1)
			$file = FileOpen($InstallDir & "Properties\au3.properties")
			Dim $properties[2]
			$i = 0
			While 1
				$properties[$i] = FileReadLine($file)
				If @error Then ExitLoop
				$i = $i + 1
				ReDim $properties[$i + 1]
			WEnd
			FileClose($file)
			$Nblignes = $i
			$Trouve = False

			$file = FileOpen($InstallDir & "Properties\au3.properties", 2)

			For $i = 0 To $Nblignes
				If StringInStr($properties[$i], "ZeShrek's DirInstall") Then
					$Trouve = True
					$ndx = StringMid($properties[$i], 3, 2)
					$properties[$i] = "# " & $ndx & " ZeShrek's DirInstall v" & $Version
					$properties[$i + 1] = "command." & $ndx & ".$(au3)=" & Chr(34) & "$(SciteDefaultHome)\DirInstall\DirInstall.exe" & Chr(34) & " /Scite"
					$properties[$i + 2] = "command.subsystem." & $ndx & ".$(au3)=1"
					$properties[$i + 3] = "command.name." & $ndx & ".$(au3)=DirInstall v" & $Version & " (CodeGen)"
					$properties[$i + 4] = "command.shortcut." & $ndx & ".$(au3)=Ctrl+Alt+i"
					$properties[$i + 5] = "command.save.before." & $ndx & ".$(au3)=2"
					$properties[$i + 6] = "command.replace.selection." & $ndx & ".$(au3)=1"
					$properties[$i + 7] = "command.quiet." & $ndx & ".$(au3)=1"
				EndIf
				FileWriteLine($file, $properties[$i])
			Next
			If $Trouve = False Then
				For $i = 0 To $Nblignes
					If StringInStr($properties[$i], "Koda") Then
						For $j = $i To $i + 7
							FileWriteLine($file, $properties[$j])
						Next
						$ndx = StringMid($properties[$i], 3, 2) + 1
						FileWriteLine($file, "# " & $ndx & " ZeShrek's DirInstall v" & $Version)
						FileWriteLine($file, "command." & $ndx & ".$(au3)=" & Chr(34) & "$(SciteDefaultHome)\DirInstall\DirInstall.exe" & Chr(34) & " /Scite")
						FileWriteLine($file, "command.subsystem." & $ndx & ".$(au3)=1")
						FileWriteLine($file, "command.name." & $ndx & ".$(au3)=DirInstall v" & $Version & " (CodeGen)")
						FileWriteLine($file, "command.shortcut." & $ndx & ".$(au3)=Ctrl+Alt+i")
						FileWriteLine($file, "command.save.before." & $ndx & ".$(au3)=2")
						FileWriteLine($file, "command.replace.selection." & $ndx & ".$(au3)=1")
						FileWriteLine($file, "command.quiet." & $ndx & ".$(au3)=1")
						$i = $i + 8

					EndIf
					FileWriteLine($file, $properties[$i])
				Next
			EndIf
			FileClose($file)
			GUICreate("DirInstall v" & $Version & " is installed", 415, 164, -1, -1, $DS_MODALFRAME)
			GUISetBkColor(0xFFFFFF)
			GUICtrlCreateLabel("DirInstall is now ready." & @CRLF & @CRLF & "Close and reopen your SciTE editor, then press <CTRL><ALT><i> or click the menu Tool / DirInstall to use it", 88, 8, 317, 65)
			GUICtrlCreatePic("", 8, 8, 64, 64, BitOR($SS_NOTIFY, $WS_GROUP, $WS_CLIPSIBLINGS))
			_ResourceSetImageToCtrl(-1, "LOGO")
			$Button1 = GUICtrlCreateButton("Ok", 160, 104, 75, 25, $WS_GROUP)
			GUISetState(@SW_SHOW)
			While 1
				$nMsg = GUIGetMsg()
				Switch $nMsg
					Case $GUI_EVENT_CLOSE, $Button1
						Exit
				EndSwitch
			WEnd
		EndIf
	EndIf

EndFunc   ;==>_PluginInstall

Func RemoveCheckbox($nTV, $nID)
	Local $TVM_SETITEM = $TV_FIRST + 13
	Local $hItem = GUICtrlGetHandle($nID)
	If $hItem = 0 Then $hItem = $nID
	Local $stTVITEM = DllStructCreate('uint;uint;uint;uint;ptr;int;int;int;int;uint;int')
	DllStructSetData($stTVITEM, 1, $TVIF_STATE)
	DllStructSetData($stTVITEM, 2, $hItem)
	DllStructSetData($stTVITEM, 3, 0)
	DllStructSetData($stTVITEM, 4, $TVIS_STATEIMAGEMASK)
	GUICtrlSendMsg($nTV, $TVM_SETITEM, 0, DllStructGetPtr($stTVITEM))
EndFunc   ;==>RemoveCheckbox

Func _SelectDestination()
	Local $nMsg
	Opt("GUIOnEventMode", 0)
	GUISetState(@SW_HIDE, $Form1)
	Local $FD_return = ""
	Local $FormDestination, $FD_Group1, $FD_Radio1, $FD_Radio2, $FD_Input1, $FD_Input2, $FD_Button1, $FD_Button2, $FD_Button3, $FD_ListView1, $FD_Checkbox1
	Local $FD_label1, $FD_Label2, $FD_label3
	Dim $FD_macro[24]
	Dim $FD_SelectedMacro[2]
	$FormDestination = GUICreate("Select Destination", 545, 325, -1, -1, $DS_MODALFRAME)
	$FD_Group1 = GUICtrlCreateGroup(" Destination ", 10, 10, 520, 200)
	$FD_Radio1 = GUICtrlCreateRadio("Destination Folder", 20, 30, 113, 17)
	$FD_Input1 = GUICtrlCreateEdit("", 20, 50, 470, 21, $ES_WANTRETURN)
	$FD_Button1 = GUICtrlCreateButton("...", 490, 50, 27, 21, $WS_GROUP)
	If @OSVersion = "WIN_7" Then
		$FD_Radio2 = GUICtrlCreateRadio("Macro", 20, 90, 53, 17)
		$FD_ListView1 = GUICtrlCreateListView("Macro|Description", 20, 105, 500, 47)
	Else
		$FD_Radio2 = GUICtrlCreateRadio("Macro", 20, 90, 55, 17)
		$FD_ListView1 = GUICtrlCreateListView("Macro|Description", 20, 110, 500, 37)
	EndIf
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 0, 139)
	GUICtrlSendMsg(-1, $LVM_SETCOLUMNWIDTH, 1, 339)
	$FD_macro[00] = GUICtrlCreateListViewItem("@ScriptDir|Path to directory containing the running script", $FD_ListView1)
	$FD_macro[01] = GUICtrlCreateListViewItem("@ProgramFilesDir|Path to Program Files folder", $FD_ListView1)
	$FD_macro[02] = GUICtrlCreateListViewItem("@CommonFilesDir|Path to Common Files folder", $FD_ListView1)
	$FD_macro[03] = GUICtrlCreateListViewItem("@WindowsDir|Path to Windows folder", $FD_ListView1)
	$FD_macro[04] = GUICtrlCreateListViewItem("@SystemDir|Path to Windows' System (or System32) folder", $FD_ListView1)
	$FD_macro[05] = GUICtrlCreateListViewItem("@TempDir|Path to the temporary files folder", $FD_ListView1)
	$FD_macro[06] = GUICtrlCreateListViewItem("|", $FD_ListView1)
	$FD_macro[07] = GUICtrlCreateListViewItem("@DesktopCommonDir|Path to Desktop", $FD_ListView1)
	$FD_macro[08] = GUICtrlCreateListViewItem("@DocumentsCommonDir|Path to Documents", $FD_ListView1)
	$FD_macro[09] = GUICtrlCreateListViewItem("@FavoritesCommonDir|Path to Favorites", $FD_ListView1)
	$FD_macro[10] = GUICtrlCreateListViewItem("@ProgramsCommonDir|Path to Start Menu's Programs folder", $FD_ListView1)
	$FD_macro[11] = GUICtrlCreateListViewItem("@StartMenuCommonDir|Path to Start Menu folder", $FD_ListView1)
	$FD_macro[12] = GUICtrlCreateListViewItem("@StartupCommonDir|Path to Startup folder", $FD_ListView1)
	$FD_macro[13] = GUICtrlCreateListViewItem("|", $FD_ListView1)
	$FD_macro[14] = GUICtrlCreateListViewItem("@AppDataDir|Path to current user's Application Data", $FD_ListView1)
	$FD_macro[15] = GUICtrlCreateListViewItem("@DesktopDir|Path to current user's  Desktop", $FD_ListView1)
	$FD_macro[16] = GUICtrlCreateListViewItem("@MyDocumentsDir|Path to My Documents target", $FD_ListView1)
	$FD_macro[17] = GUICtrlCreateListViewItem("@FavoritesDir|Path to current user's Favorites", $FD_ListView1)
	$FD_macro[18] = GUICtrlCreateListViewItem("@ProgramsDir|Path to current user's Programs (folder on Start Menu)", $FD_ListView1)
	$FD_macro[19] = GUICtrlCreateListViewItem("@StartMenuDir|Path to current user's Start Menu", $FD_ListView1)
	$FD_macro[20] = GUICtrlCreateListViewItem("@StartupDir|Path to current user's Startup folder", $FD_ListView1)
	$FD_macro[21] = GUICtrlCreateListViewItem("@UserProfileDir|Path to current user's Profile folder", $FD_ListView1)
	$FD_macro[22] = GUICtrlCreateListViewItem("@HomeDrive&@HomePath|Directory part of current user's home directory", $FD_ListView1)
	$FD_macro[23] = GUICtrlCreateListViewItem("@HomeShare|Server and share name containing current user's home directory", $FD_ListView1)
	$FD_Checkbox1 = GUICtrlCreateCheckbox("SubFolder in Directory Macro", 50, 160, 160, 17)
	$FD_label1 = GUICtrlCreateLabel("@ScriptDir\", 20, 183, 140, 21, $SS_RIGHT)
	$FD_Input2 = GUICtrlCreateInput("", 162, 180, 358, 21)
	$FD_Label2 = GUICtrlCreateLabel("Your files will be 'FileInstalled' in :", 15, 215, 158, 17)
	$FD_label3 = GUICtrlCreateLabel("", 15, 235, 500, 21, -1, $WS_EX_CLIENTEDGE)
	GUICtrlSetBkColor($FD_label3, 0xFFFFFF)
	$FD_Button2 = GUICtrlCreateButton("Ok", 24, 265, 75, 25, $WS_GROUP)
	$FD_Button3 = GUICtrlCreateButton("Cancel", 446, 265, 75, 25, $WS_GROUP)
	GUISetState(@SW_SHOW, $FormDestination)
	GUICtrlSetState($FD_Radio1, $GUI_CHECKED)
	GUICtrlSetState($FD_ListView1, $GUI_DISABLE)
	GUICtrlSetState($FD_Checkbox1, $GUI_DISABLE)
	GUICtrlSetState($FD_Input2, $GUI_DISABLE)
	GUICtrlSetState($FD_Button2, $GUI_DISABLE)
	_GUICtrlListView_SetItemSelected($FD_ListView1, 0, True, True)
	While 1
		$nMsg = GUIGetMsg()
		Switch $nMsg
			Case $FD_Button3
				$FD_return = ""
				ExitLoop
			Case $FD_Radio1
				GUICtrlSetState($FD_Radio2, $GUI_UNCHECKED)
				GUICtrlSetState($FD_Input1, $GUI_ENABLE)
				GUICtrlSetState($FD_Button1, $GUI_ENABLE)
				GUICtrlSetState($FD_ListView1, $GUI_DISABLE)
				GUICtrlSetState($FD_Checkbox1, $GUI_DISABLE)
				GUICtrlSetState($FD_Input2, $GUI_DISABLE)
				GUICtrlSetData($FD_label3, _GUICtrlEdit_GetText($FD_Input1))
			Case $FD_Radio2
				GUICtrlSetState($FD_Radio1, $GUI_UNCHECKED)
				GUICtrlSetState($FD_Input1, $GUI_DISABLE)
				GUICtrlSetState($FD_Button1, $GUI_DISABLE)
				GUICtrlSetState($FD_ListView1, $GUI_ENABLE)
				GUICtrlSetState($FD_Checkbox1, $GUI_ENABLE)
				If BitOR(GUICtrlRead($FD_Checkbox1), $GUI_CHECKED) = $GUI_CHECKED Then
					GUICtrlSetState($FD_Input2, $GUI_ENABLE)
				Else
					GUICtrlSetState($FD_Input2, $GUI_DISABLE)
				EndIf
			Case $FD_Checkbox1
				If BitOR(GUICtrlRead($FD_Checkbox1), $GUI_CHECKED) = $GUI_CHECKED Then
					GUICtrlSetState($FD_Input2, $GUI_ENABLE)
				Else
					GUICtrlSetState($FD_Input2, $GUI_DISABLE)
				EndIf
			Case $FD_Button1
				$FD_return = FileSelectFolder("root", -1, 2, @WorkingDir & "\")
				If $FD_return <> "" Then
					If StringRight($FD_return, 1) <> "\" Then
						$FD_return = $FD_return
					EndIf
					GUICtrlSetData($FD_Input1, $FD_return)
					GUICtrlSetData($FD_label3, _GUICtrlEdit_GetText($FD_Input1))
				EndIf
			Case $FD_Button2
				If StringLeft($FD_return, 1) = "@" Then ; macro
					$FD_return = StringReplace($FD_return, "\", " & " & Chr(34) & "\", 1)
					$FD_return = StringReplace($FD_return, "&@", " & " & Chr(34) & "\" & Chr(34) & " & @")
				Else ; chemin local ou UNC
					$FD_return = Chr(34) & $FD_return
				EndIf
				If StringRight($FD_return, 1) <> "\" Then $FD_return = $FD_return & "\"
				ExitLoop
			Case Else
				For $i = 0 To 23
					If $nMsg = $FD_macro[$i] Then
						$FD_SelectedMacro = _GUICtrlListView_GetItemTextArray($FD_ListView1, $i)
						GUICtrlSetData($FD_label1, $FD_SelectedMacro[1] & "\")
						$FD_return = $FD_SelectedMacro[1] & "\" & _GUICtrlEdit_GetText($FD_Input2)
						If GUICtrlRead($FD_label1) <> "\" Then
							GUICtrlSetState($FD_Button2, $GUI_ENABLE)
						Else
							GUICtrlSetState($FD_Button2, $GUI_DISABLE)
						EndIf
					EndIf
				Next
		EndSwitch
		If BitAND(GUICtrlRead($FD_Radio1), $GUI_CHECKED) = $GUI_CHECKED And _GUICtrlEdit_CanUndo($FD_Input1) = True Then
			GUICtrlSetData($FD_label3, _GUICtrlEdit_GetText($FD_Input1))
			_GUICtrlEdit_EmptyUndoBuffer($FD_Input1)
			$FD_return = GUICtrlRead($FD_label3)
		ElseIf BitAND(GUICtrlRead($FD_Radio2), $GUI_CHECKED) = $GUI_CHECKED And BitAND(GUICtrlRead($FD_Checkbox1), $GUI_UNCHECKED) = $GUI_UNCHECKED And GUICtrlRead($FD_label3) <> GUICtrlRead($FD_label1) Then
			GUICtrlSetData($FD_label3, GUICtrlRead($FD_label1))
			$FD_return = GUICtrlRead($FD_label3)
		ElseIf BitAND(GUICtrlRead($FD_Radio2), $GUI_CHECKED) = $GUI_CHECKED And BitAND(GUICtrlRead($FD_Checkbox1), $GUI_CHECKED) = $GUI_CHECKED And GUICtrlRead($FD_label3) <> GUICtrlRead($FD_label1) & _GUICtrlEdit_GetText($FD_Input2) Then
			GUICtrlSetData($FD_label3, GUICtrlRead($FD_label1) & _GUICtrlEdit_GetText($FD_Input2))
			$FD_return = GUICtrlRead($FD_label3)
		EndIf
		If GUICtrlRead($FD_label3) = "" or (StringMid(GUICtrlRead($FD_label3), 1, 1) <> "@" And StringMid(GUICtrlRead($FD_label3), 1, 2) <> "\\" And StringMid(GUICtrlRead($FD_label3), 2, 2) <> ":\") And BitAND(GUICtrlGetState($FD_Button2), $GUI_DISABLE) <> $GUI_DISABLE Then
			GUICtrlSetState($FD_Button2, $GUI_DISABLE)
		ElseIf StringMid(GUICtrlRead($FD_label3), 1, 1) = "@" Or StringMid(GUICtrlRead($FD_label3), 1, 2) = "\\" Or StringMid(GUICtrlRead($FD_label3), 2, 2) = ":\" And BitAND(GUICtrlGetState($FD_Button2), $GUI_ENABLE) <> $GUI_ENABLE Then
			GUICtrlSetState($FD_Button2, $GUI_ENABLE)
		EndIf
	WEnd
	GUIDelete($FormDestination)
	GUISetState(@SW_SHOW, $Form1)
	Opt("GUIOnEventMode", 1)
	Return ($FD_return)
EndFunc   ;==>_SelectDestination

Func _Valid()
	Local $CreateFolder, $DirInstall, $FileInstall
	$CreateFolder = ";~ Folders creation" & @CRLF
	$CreateFolder = $CreateFolder & "DirCreate(" & $Destpath & Chr(34) & ")" & @CRLF
	For $i = 1 To $Idx
		If $TreeViewItem[$i][3] = 1 And BitAND(GUICtrlRead($TreeViewItem[$i][0]), $GUI_CHECKED) = $GUI_CHECKED Then
			$CreateFolder = $CreateFolder & "DirCreate(" & $Destpath & $TreeViewItem[$i][2] & Chr(34) & ")" & @CRLF
			If BitOR(GUICtrlRead($ProgressYesNo), $GUI_CHECKED) = $GUI_CHECKED Then $CreateFolder = $CreateFolder & "GUICtrlSetData($DirInstallProgress, " & Int(($i / $Idx) * 100) & ")" & @CRLF
		EndIf
	Next
	$FileInstall = ";~ Files creation" & @CRLF
	For $i = 1 To $Idx
		If $TreeViewItem[$i][3] = 0 And BitAND(GUICtrlRead($TreeViewItem[$i][0]), $GUI_CHECKED) = $GUI_CHECKED Then
			$FileInstall = $FileInstall & "FileInstall(" & Chr(34) & $rootpath & "\" & $TreeViewItem[$i][2] & Chr(34) & ", " & $Destpath & $TreeViewItem[$i][2] & Chr(34) & ", 1)" & @CRLF
			If BitOR(GUICtrlRead($ProgressYesNo), $GUI_CHECKED) = $GUI_CHECKED Then $FileInstall = $FileInstall & "GUICtrlSetData($DirInstallProgress, " & Int(($i / $Idx) * 100) & ")" & @CRLF
		EndIf
	Next
	$DirInstall = "#Region ### START ZeShrek's DirInstall v" & $Version & " Section ###" & @CRLF
	If BitOR(GUICtrlRead($ProgressYesNo), $GUI_CHECKED) = $GUI_CHECKED Then
		$DirInstall = $DirInstall & "	;~ ProgressBar GUI" & @CRLF
		$DirInstall = $DirInstall & "Local $DirInstallForm, $DirInstalllabel, $DirInstallProgress" & @CRLF
		$DirInstall = $DirInstall & "$DirInstallForm = GUICreate(" & Chr(34) & "Install in progress" & Chr(34) & ", 280, 125, -1, -1, $DS_MODALFRAME, 0)" & @CRLF
		$DirInstall = $DirInstall & "$DirInstalllabel = GUICtrlCreateLabel(" & Chr(34) & "Please wait during files installation." & Chr(34) & ", 10, 20, 260, 49)" & @CRLF
		$DirInstall = $DirInstall & "$DirInstallProgress = GUICtrlCreateProgress(30, 65, 200, 25)" & @CRLF
		$DirInstall = $DirInstall & "GUISetState(@SW_SHOW, $DirInstallForm)" & @CRLF
	EndIf
	If $CreateFolder <> ";~ Folders creation" & @CRLF Then
		$DirInstall = $DirInstall & $CreateFolder
	EndIf
	If $FileInstall <> ";~ Files creation" & @CRLF Then
		$DirInstall = $DirInstall & $FileInstall
	EndIf
	$DirInstall = $DirInstall & "#EndRegion ### END ZeShrek's DirInstall v" & $Version & " Section ###" & @CRLF
	ClipPut($DirInstall)
	ConsoleWrite($DirInstall)
	Exit
EndFunc   ;==>_Valid
#EndRegion *** Fonctions